﻿using System;
using System.Windows;
using System.Windows.Controls;

using System.Collections.Generic;
using System.IO;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Documents.FormatProviders;
using Telerik.Windows.Documents.Model;

namespace ExportGridToPDFDemo
{

    public partial class MainPage : UserControl
    {

        #region Variables

        // Private Variables
        private List<Users> _users = null;
        private Users _user = null;

        #endregion

        #region Constructor

        public MainPage()
        {

            // Initialize Component
            InitializeComponent();

            #region Setup Data / Grid

            // Initialize Class
            this._users = new List<Users>();
            // Create User 1
            _user = new Users();
            // Assign Values
            _user.FirstName = "Bill";
            _user.Surname = "Clinton";
            _user.Username = "BillC";
            // Add User
            this._users.Add(this._user);

            // Create User 2
            _user = new Users();
            // Assign Values
            _user.FirstName = "George";
            _user.Surname = "Bush";
            _user.Username = "GeorgeB";
            // Add User
            this._users.Add(this._user);

            // Create User 3
            _user = new Users();
            // Assign Values
            _user.FirstName = "Barack";
            _user.Surname = "Obama";
            _user.Username = "BarackO";
            // Add User
            this._users.Add(this._user);

            // Assign Items
            this.grdList.ItemsSource = this._users;

            #endregion


        }

        #endregion
        
        #region cmdExport_Click

        private void cmdExport_Click(object sender, RoutedEventArgs e)
        {

            SaveFileDialog saveFileDialog = null;
            RadDocument document = null;

            try
            {

                #region Export Records

                // Initialize Class
                saveFileDialog = new SaveFileDialog();
                // Generate Document
                document = RadGridViewPDFExport.Export(this.grdList);
                // Assign Values
                saveFileDialog.DefaultExt = "PDF";
                saveFileDialog.Filter = String.Format("PDF Files (*.{0})|*.{0}|All Files (*.*)|*.*", saveFileDialog.DefaultExt);

                // Show Dialog
                if (saveFileDialog.ShowDialog().Equals(true))
                {

                    // Initialize Class
                    using (Stream stream = saveFileDialog.OpenFile())
                    {

                        // Check Value
                        if (document != null)
                        {

                            // Initialize Class
                            var provider = DocumentFormatProvidersManager.GetProviderByExtension(".PDF");
                            // Export
                            provider.Export(document,
                                stream);
                            // Close Stream
                            stream.Close();

                        }

                    }

                }

                #endregion

            }
            catch (Exception ex)
            {

                #region Return Error Message

                // Return Error Message
                MessageBox.Show(String.Format("An error occurred while exporting the Records - {0}", ex.Message));

                #endregion

            }

        }

        #endregion

    }

}
